aaflush proc
		push es
		mov esi,640
		push fs
		mov ax,[VideoSelector]
		mov bx,[ScreenBuffer]
		mov es,ax		;load video selector
		mov fs,bx
		xor edx,edx		;clear bankswitch
		xor ebx,ebx
		xor eax,eax

 aFlushLoop:	mov cl,cs:[BankShift]
		push edx
		shl edx,cl		;calculate bank shift
		push eax
		xor ebx,ebx
		mov ax,4f05h
		int 10h			;call vesa bank switch

pop eax
cmp eax,4
je jjd
push eax
		xor edi,edi		;start at beginning of screen
		mov ecx,010000h		;loop this many times (DW = 4 B)
jmp aaloop

jjd:
xor edi,edi
mov ecx,08000h
push eax
aaloop:
	push ecx
	xor eax,eax			;
	xor ebx,ebx			;
	xor ecx,ecx			;
	xor edx,edx			;

	mov ax,fs:[esi-1]		;grab points around point
	mov bx,fs:[esi-640]
	mov cx,fs:[esi+1]
	mov dx,fs:[esi+640]
	and ax,11111b
	and bx,11111b
	and cx,11111b
	and dx,11111b
	add ax,bx
	add ax,cx
	add ax,dx
	mov bx,fs:[esi]
	and bx,11111b
	shl bx,2
	add ax,bx
	shr ax,3
	mov bp,ax

	mov ax,fs:[esi-1]		;grab points around point
	mov bx,fs:[esi-640]
	mov cx,fs:[esi+1]
	mov dx,fs:[esi+640]
	shr ax,5
	shr bx,5
	shr cx,5
	shr dx,5
	and ax,111111b
	and bx,111111b
	and cx,111111b
	and dx,111111b
	add ax,bx
	add ax,cx
	add ax,dx
	mov bx,fs:[esi]
	shr bx,5
	and bx,111111b
	shl bx,2
	add ax,bx
	shr ax,3
	shl ax,5
	or bp,ax

	mov ax,fs:[esi-1]		;grab points around point
	mov bx,fs:[esi-640]
	mov cx,fs:[esi+1]
	mov dx,fs:[esi+640]
	shr ax,11
	shr bx,11
	shr cx,11
	shr dx,11
	and ax,11111b
	and bx,11111b
	and cx,11111b
	and dx,11111b
	add ax,bx
	add ax,cx
	add ax,dx
	mov bx,fs:[esi]
	shr bx,11
	and bx,11111b
	shl bx,2
	add ax,bx
	shr ax,3
	shl ax,11
	or bp,ax

	mov ax,bp
	mov es:[edi],ax	;store new color & shade

	add esi,2
	add edi,2

pop ecx
dec ecx
jnz aaloop

		pop eax
		pop edx
		inc eax
		inc edx
		cmp eax,9
		jb cs:aFlushLoop

		pop fs
		pop es
		ret
ENDP