;displays all outline boxes

		mov eax,dword ptr fs:[(Object + edi).xtrans]
		;mov bx,fs:[(Object + edi).ytrans]
		mov dx,fs:[(Object + edi).ztrans]
		mov dword ptr [tx],eax
		;mov [ty],bx
		mov [tz],dx

		cmp [state],1
		jne SN

		mov al,[brotx]
		mov bl,[broty]
		mov dl,[brotz]
		mov [rotx],al
		mov [roty],bl
		mov [rotz],dl
		call RotSet

		xor ecx,ecx

BoxLoop:
;sets up each point for future - nextbox is point it will draw
;*** Can swap add Xx,[bpointerX]'s up right before mov [rX],Xx
		mov ax,[box+ecx]
		mov bx,[box+ecx+2]
		mov dx,[box+ecx+4]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		mov [rz],dx
		push ecx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		pop ecx
		mov [nextbox+ecx],ax
		mov [nextbox+ecx+2],bx
		mov [nextbox+ecx+4],dx

		mov ax,[box+ecx+6]
		mov bx,[box+ecx+8]
		mov dx,[box+ecx+10]
		add ax,[bfptrx]		;moving relative to rot point
		add bx,[bfptry]
		add dx,[bfptrz]
		mov [rx],ax
		mov [ry],bx
		push ecx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		pop ecx
		mov bx,[ry]
		mov dx,[rz]
		add ax,[bpointerx]
		add bx,[bpointery]
		add dx,[bpointerz]
		mov [nextbox+ecx+6],ax
		mov [nextbox+ecx+8],bx
		mov [nextbox+ecx+10],dx

		add ecx,6
		cmp ecx,4*6
		jb BoxLoop


;******************************
SN:		;time to draw points

		mov ax,word ptr fs:[(Object + edi).xrot]
		;mov bl,fs:[(Object + edi).yrot]
		mov dl,fs:[(Object + edi).zrot]
		mov word ptr [rotx],ax
		;mov [roty],bl
		mov [rotz],dl
		call RotSet

		cmp [state],1	;skip drawing insides if defining region
		je NoMouseState ;(could be going flexi)

	;draw texture map of new polygon - where plotted points will show up
		;Rotate Points for drawing
		mov eax,dword ptr [nextbox]
		;mov bx,[nextbox+2]
		mov dx,[nextbox+4]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt1x],eax
		;mov [pt1y],bx
		mov [pt1z],dx

		mov eax,dword ptr [nextbox+6]
		;mov bx,[nextbox+8]
		mov dx,[nextbox+10]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt2x],eax
		;mov [pt2y],bx
		mov [pt2z],dx

		mov eax,dword ptr [nextbox+18]
		;mov bx,[nextbox+20]
		mov dx,[nextbox+22]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt3x],eax
		;mov [pt3y],bx
		mov [pt3z],dx

		mov eax,dword ptr [nextbox+12]
		;mov bx,[nextbox+14]
		mov dx,[nextbox+16]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov eax,dword ptr [rx]
		;mov bx,[ry]
		mov dx,[rz]
		mov dword ptr [pt4x],eax
		;mov [pt4y],bx
		mov [pt4z],dx

		;add on transitioning
		mov ax,[tx]
		mov bx,[ty]
		add [pt1x],ax
		mov dx,[tz]
		add [pt2x],ax
		add [pt1y],bx
		add [pt3x],ax
		add [pt4z],dx
		add [pt2y],bx
		add [pt2z],dx
		add [pt4x],ax
		add [pt3y],bx
		add [pt1z],dx
		add [pt4y],bx
		add [pt3z],dx

		movsx eax,[pt1x]	;load x
		movsx ebx,[pt1z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt1x],ax		;save new x value
	      ;y1
		movsx eax,[pt1y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt1y],ax
	     ;x2
		movsx eax,[pt2x]	;load x
		movsx ebx,[pt2z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt2x],ax		;save new x value
	      ;y2
		movsx eax,[pt2y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt2y],ax
	      ;x3
		movsx eax,[pt3x]	;load x
		movsx ebx,[pt3z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt3x],ax		;save new x value
	      ;y3
		movsx eax,[pt3y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt3y],ax
	      ;x4
		movsx eax,[pt4x]	;load x
		movsx ebx,[pt4z]	;load z
		shl eax,zshift		;multiply eax by 256
		cdq
		add ebx,zadd		;add displacement to z
		idiv ebx		;divide edx:eax by ebx
		add ax,[LeftOfScreen] 	;move to where screen is
		mov [pt4x],ax		;save new x value
	      ;y4
		movsx eax,[pt4y]	;load y
		shl eax,zshift		;mul ax by 256
		cdq
		idiv ebx		;divide dx:ax by bx
		add ax,[TopOfScreen]	;move to where screen is
		mov [pt4y],ax


		call FindZNormal
		mov [ttemp],ecx		;save for later


		cmp [state],3	;skip drawing insides if flexi
		je NoMouseState	;needed to do the above to find the z-normal
				;for hsr

		mov [Shade],0
		;mov [skipaa],1
		mov [numverts],0
		mov [vertsat],0
		mov ax,[box+6]
		mov bx,[box+20]
		sub ax,[box]
		sub bx,[box+2]
		mov [pixlen],ax
		mov [pixheight],bx
		mov eax,[ClrMap]
		mov [MapOffset],eax

		;store these for mouse map overlay
		mov eax,dword ptr [pt1x]
			;push dword ptr [pt1x]
				;push [pt1y]
		mov ebx,dword ptr [pt1z]
		push eax
			;push dword ptr [pt1z]
				;push [pt2x]
		mov ecx,dword ptr [pt2y]
		push ebx
			;push dword ptr [pt2y]
				;push [pt2z]
		mov eax,dword ptr [pt3x]
		push ecx
			;push dword ptr [pt3x]
				;push [pt3y]
		mov ebx,dword ptr [pt3z]
		push eax
			;push dword ptr [pt3z]
				;push [pt4x]
		mov ecx,dword ptr [pt4y]
		push ebx
		push ecx
			;push dword ptr [pt4y]
				;push [pt4z]

		mov [AllowDepth],0
		call TextureMap
		mov [AllowDepth],1

				;pop [pt4z]
		pop eax	;pop dword ptr [pt4y]

				;pop [pt4x]
		pop ebx	;pop dword ptr [pt3z]
		mov dword ptr [pt4y],eax
				;pop [pt3y]
		pop ecx	;pop dword ptr [pt3x]
		mov dword ptr [pt3z],ebx
				;pop [pt2z]
		pop eax	;pop dword ptr [pt2y]
		mov dword ptr [pt3x],ecx
				;pop [pt2x]
		pop ebx	;pop dword ptr [pt1z]
		mov dword ptr [pt2y],eax
				;pop [pt1y]
		pop ecx	;pop dword ptr [pt1x]
		mov dword ptr [pt1z],ebx
		mov dword ptr [pt1x],ecx

	;do this if in the mouse state (overlay map of mouse image)
		cmp [state],2
		jne NoMouseState

		call updatemptr

		mov [Shade],0
		;mov [skipaa],1
		mov [numverts],0
		mov [vertsat],0
		mov ax,[box+6]
		mov bx,[box+20]
		sub ax,[box]
		sub bx,[box+2]
		mov [pixlen],ax
		mov [pixheight],bx
		mov eax,[ClrMouse]
		mov [MapOffset],eax
	;mouse map overlay!
		mov [AllowDepth],0
		call TextureMap
		mov [AllowDepth],1
	NoMouseState:
		;mov [skipaa],0



;Now draw outline
comment ~
		mov [bcolor],255	;color of line (white)
		call FindZNormal
		cmp ecx,0
		jl aclr
		mov [bcolor],102
	aclr:
		mov al,[bcolor]
~
		mov ax,[foreground]
		xor ecx,ecx	;counter
		mov [color],ax ;al;load color - from up in texture map
		;shade color if hsr is on, and applies
		cmp [hidden],1		;see if hsr is turned off
		je BoxLoopie
		cmp [ttemp],0
		jl BoxLoopie
		mov [color],821h

	BoxLoopie:

		mov eax,dword ptr [nextbox+ecx]
		;mov bx,[nextbox+ecx+2]
		mov dx,[nextbox+ecx+4]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		push ecx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[tx]
		add bx,[ty]
		add dx,[tz]
		mov [pt1x],ax
		mov [pt1y],bx
		pop ecx
		mov [pt1z],dx

		mov eax,dword ptr [nextbox+ecx+6]
		;mov bx,[nextbox+ecx+8]
		mov dx,[nextbox+ecx+10]
		mov dword ptr [rx],eax
		;mov [ry],bx
		push ecx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		pop ecx
		mov bx,[ry]
		mov dx,[rz]
		add ax,[tx]
		add bx,[ty]
		add dx,[tz]
		mov [pt2x],ax
		mov [pt2y],bx
		mov [pt2z],dx
		push ecx

		call DrawLine

		pop ecx
		add ecx,6
		cmp ecx,4*6
		jb BoxLoopie	;loop if not done