;display texture map editor

	;outline of polygon
		;initialize
		mov eax,dword ptr fs:[(Object + edi).xtrans]
		;mov bx,fs:[(Object + edi).ytrans]
		mov dx,fs:[(Object + edi).ztrans]
		mov dword ptr [tx],eax
		;mov [ty],bx
		mov [tz],dx
		mov eax,dword ptr fs:[(Object + edi).xrot]
		;mov bl,fs:[(Object + edi).yrot]
		;mov dl,fs:[(Object + edi).zrot]
		mov dword ptr [rotx],eax
		;mov [roty],bl
		;mov [rotz],dl
		call RotSet

		;begin
		mov esi,fs:[(Object + edi).ToPolys]
		mov ax,[OnPoly]		;find out what polygon
		mov bx,SizeofPolyS
		mul bx
		shl edx,16
		mov dx,ax
		add esi,edx		;find pointer to polygon to edit
		xor cx,cx		;clear for later
		mov edi,fs:[(Polygon + esi).ToPoints]	;get points
		mov cl,fs:[(Polygon + esi).NumPoints]	;""
		;inc cx	don't need to increment it, because auto takes 1st pt
		mov eax,dword ptr fs:[edi] ;pt1x
		;mov bx,fs:[edi+2]	;pt1y
		mov dx,fs:[edi+4]	;pt1z
		mov dword ptr [pt3x],eax
		;mov [pt3y],bx
		mov [pt3z],dx
		add edi,6	;next point

	S4PLoop:
		mov eax,dword ptr [pt3x]
		;mov bx,[pt3y]
		mov dx,[pt3z]
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		push cx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[tx]
		add bx,[ty]
		add dx,[tz]
		mov [pt1x],ax
		mov [pt1y],bx
		mov [pt1z],dx

		mov eax,dword ptr fs:[edi] ;x
		;mov bx,fs:[edi+2]	;y
		mov dx,fs:[edi+4]	;z
		mov dword ptr [pt3x],eax
		;mov [pt3y],bx
		mov [pt3z],dx
		mov dword ptr [rx],eax
		;mov [ry],bx
		mov [rz],dx
		call Rotate
		mov ax,[rx]
		mov bx,[ry]
		mov dx,[rz]
		add ax,[tx]
		add bx,[ty]
		add dx,[tz]
		mov [pt2x],ax
		mov [pt2y],bx
		mov ax,[foreground]	;load color
		mov [pt2z],dx

		mov [color],ax
		call DrawLine
		pop cx
		dec cx
		add edi,6
		cmp cl,0
		ja S4PLoop


	;draw edit box in lower left hand corner
		;- like paint brush


		mov ebx,fs:[(Polygon + esi).ToMap]	;get map
		;mov [skipaa],1		;turn off anti-aliasing
		mov [MapOffset],ebx
		mov [Shade],0		;turn off shading
		mov [cMap],ebx		;store for painting

		mov ax,fs:[(Polygon + esi).numhpix]	;get height
		mov bx,[tmeditat+2] ;y
		mov [pixheight],ax
		add bx,480	;adjust to screen (screen is back)
		add ax,bx	;find height ending location

		mov [pt1y],bx
		mov [pt2y],bx
		mov [pt3y],ax	;(+480 = screen adjust)
		mov [pt4y],ax

		mov ax,fs:[(Polygon + esi).numlpix]	;get length
		mov bx,[tmeditat] ;x
		mov [pixlen],ax
		add bx,640	;adjust to screen
		add ax,bx	;find length ending location

		mov [pt1x],bx
		mov [pt2x],ax	;(640 = screen adjust)
		mov [pt3x],bx
		mov [pt4x],ax

		mov ax,[tmeditat+4]	;add extended length (bigger)
		add [pt2x],ax	;extend
		add [pt4x],ax
		add [pt3y],ax
		;mov ebx,dword ptr [pixlen]
		add [pt4y],ax


		;push ebx		;&2 lines up - replaces next 2 lines
		push [pixlen]		;store for later
		push [pixheight]


		;store these for mouse map overlay
		mov eax,dword ptr [pt1x]
			;push dword ptr [pt1x]
				;push [pt1y]
		mov ebx,dword ptr [pt1z]
		push eax
			;push dword ptr [pt1z]
				;push [pt2x]
		mov ecx,dword ptr [pt2y]
		push ebx
			;push dword ptr [pt2y]
				;push [pt2z]
		mov eax,dword ptr [pt3x]
		push ecx
			;push dword ptr [pt3x]
				;push [pt3y]
		mov ebx,dword ptr [pt3z]
		push eax
			;push dword ptr [pt3z]
				;push [pt4x]
		mov ecx,dword ptr [pt4y]
		push ebx
		push ecx
			;push dword ptr [pt4y]
				;push [pt4z]

		mov [AllowDepth],0
		call TextureMap
		mov [AllowDepth],1

				;pop [pt4z]
		pop eax	;
;pop dword ptr [pt4y]

				;pop [pt4x]
		pop ebx	;
;pop dword ptr [pt3z]
		mov dword ptr [pt4y],eax
				;pop [pt3y]
		pop ecx	;
;pop dword ptr [pt3x]
		mov dword ptr [pt3z],ebx
				;pop [pt2z]
		pop eax	;
;pop dword ptr [pt2y]
		mov dword ptr [pt3x],ecx
				;pop [pt2x]
		pop ebx	;
;pop dword ptr [pt1z]
		mov dword ptr [pt2y],eax
				;pop [pt1y]
		pop ecx	;
;pop dword ptr [pt1x]
		mov dword ptr [pt1z],ebx
		mov dword ptr [pt1x],ecx



	;if editing texture map, do this
		cmp [state],5
		jne TMENoMouseState

	;clear up front buffer
		mov eax,08210821h
		mov ecx,65536*2
		push es
		push fs
		pop es
		mov edi,[ClrMouse]
		cld
	    rep stosd
		pop es
		mov edi,[ClrMouse]

	;plot mouse points
		;get pixlen & height early
		pop bx
		pop ax
		mov [pixlen],ax
		mov [clen],ax
		mov [pixheight],bx
		mov [cheight],bx
		push ax
		push bx

		mov bx,[tmey]
		mul bx		;multiply pixlen (ax) by tmey
		shl edx,16
		add ax,[tmex]	;add on x value
		xor ebx,ebx
		mov dx,ax	;adjust into edx
		shl edx,1
		mov bx,[pixlen]
		add edi,edx

		mov cx,[foreground]	;load color
		cmp edx,ebx
		jb NotAb
		neg ebx
		mov word ptr fs:[edi+2*ebx],cx
		neg ebx
	  NotAb:

		mov word ptr fs:[edi+2],cx	;move mouse in
		mov word ptr fs:[edi-2],cx	;move mouse in
		mov word ptr fs:[edi+2*ebx],cx	;move mouse in

		mov [Shade],0
		;mov [skipaa],1
		mov [numverts],0
		mov [vertsat],0
		mov eax,[ClrMouse]
		mov [MapOffset],eax
	;mouse map overlay!
		mov [AllowDepth],0
		call TextureMap
		mov [AllowDepth],1
	TMENoMouseState:

		;mov [skipaa],0

	;display statistics

		;display any statistics (retain edi)
		mov cx,10
		mov bx,5
		mov edx,0a000ah
		mov esi,offset editstr
		call Write

		mov cx,500
		mov bx,73
		mov edx,0a000ah
		mov esi,offset hstr
		call Write
		pop ax
		call ShowDec

		mov cx,500
		mov bx,84
		mov edx,0a000ah
		mov esi,offset wstr
		call Write
		pop ax
		call ShowDec

		mov cx,500
		mov bx,95
		mov edx,0a000ah
		mov esi,offset magstr
		call Write
		mov ax,[tmeditat+4]
		call ShowDec


		cmp [state],5	;see if editing
		jne SkipClPk	;color picker

		mov cx,500
		mov bx,130
		mov edx,0a000ah
		mov esi,offset colstr
		call Write

		mov cx,500
		xor ax,ax
		mov bx,152
		mov edx,0a000ah
		cmp [ColPt],0
		jne NRSPC
		mov esi,offset space
		call Write
	NRSPC:
		mov esi,offset rstr
		call Write
		mov ax,[OnColor]
		shr ax,11
		and ax,11111b
		call ShowDec

		mov cx,500
		xor ax,ax
		mov bx,163
		mov edx,0a000ah
		cmp [ColPt],1
		jne NGSPC
		mov esi,offset space
		call Write
	NGSPC:
		mov esi,offset gstr
		call Write
		mov ax,[OnColor]
		shr ax,5
		and ax,111111b
		call ShowDec

		mov cx,500
		xor ax,ax
		mov bx,174
		mov edx,0a000ah
		cmp [ColPt],2
		jne NBSPC
		mov esi,offset space
		call Write
	NBSPC:
		mov esi,offset bstr
		call Write
		mov ax,[OnColor]
		and ax,11111b
		call ShowDec



		mov eax,[ClrMouse]
		mov [pt1x],500+640
		add eax,512		;go deep enough into buffer
		mov [pt1y],210+480
		mov bx,[OnColor]
		mov word ptr fs:[eax],bx
		mov [pt2x],570+640
		mov [pt2y],210+480
		mov [pt3x],500+640
		mov [pt3y],250+480
		mov [pt4x],570+640
		mov [pt4y],250+480

		mov [Shade],0
		;mov [skipaa],1
		mov [MapOffset],eax
		mov [pixlen],1
		mov [pixheight],1
		mov [AllowDepth],0
		call TextureMap	;blank area for writing
		;mov [skipaa],0

	SkipClPk: