		;allocate memory for object
		mov ax,501h
		xor cx,cx	;allocate 3MB of memory (to be safe)
		mov bx,80h
		int 31h
		jnc SAOK

		mov edi,offset AllocErr
		mov ah,1
		xor ebx,ebx
		xor eax,eax
		xor edx,edx
		call PrintError
		mov ax,4c00h
		int 21h
	SAOK:
	;Allocation Safe
		shl ebx,16
		mov bx,cx
		mov [NewObject],ebx

include stack.inc


	;allocate memory for default texture maps & fill them
		mov ax,501h
		xor cx,cx
		mov bx,60
		int 31h
		shl ebx,16	;put address in ebx
		mov bx,cx
		mov [Map],ebx
		add ebx,2000h	;end of checker texture map
		mov [ClrMap],ebx
		add ebx,20000h
		mov [ClrMouse],ebx

		;fill everything
		push es
		push fs
		pop es

		mov ecx,800h
		mov eax,000150015h;02020202h;18181818h;1048a830h
		mov edi,[Map]
	    rep stosd

		mov ecx,8000h
		mov eax,08210821h
	    rep stosd

	;	mov ecx,1000h
	;	mov eax,08210821h
	;    rep stosd

		pop es
	;Done with Default Maps

		mov edi,[NewObject]
		mov fs:[(Object + edi).NumPolys],6
		mov fs:[(Object + edi).xrot],0
		mov fs:[(Object + edi).yrot],0
		mov fs:[(Object + edi).zrot],0
		mov fs:[(Object + edi).xtrans],0
		mov fs:[(Object + edi).ytrans],0
		mov fs:[(Object + edi).ztrans],0
		mov eax,edi
		add eax,60
		mov fs:[(Object + edi).ToPolys],eax
		mov ebx,edi
		add ebx,8000h
		mov dword ptr fs:[edi+40],ebx  ;ptr to points
	;	mov dword ptr fs:[edi+44],esi
	;	mov dword ptr fs:[edi+48],0	;haven't drawn poly yet
		mov eax,edi
		add eax,10000h
		mov dword ptr fs:[edi+52],eax ;pointer to texture maps


		;copy Side stuff over
		push es
		push fs
		pop es		;reset down below
		add edi,60	;pointer to beginning of polygons
		mov esi,offset Side
		mov ecx,66	;57*4 bytes
	    rep movsd

		;re-initialize each side
		mov cx,6
		mov edi,[NewObject]
		mov esi,edi
		add esi,8000h
		add edi,60
		mov eax,[Map]

	AllocPolyInit:
		mov fs:[(Polygon + edi).ToPoints],esi
		mov fs:[(Polygon + edi).ToMap],eax
		mov fs:[(Polygon + edi).NumPoints],4
		mov fs:[(Polygon + edi).Flags],0
		add esi,5*6		;5 points, each with 3 words (3*2)
		add edi,SizeofPolyS
		sub cx,1
		jnz AllocPolyInit

		mov ecx,47	;5*6 (see above) times 6 sides using dwords
		mov edi,[NewObject]
		add edi,8000h
		mov esi,offset TopA
	    rep movsd
		pop es		;from above


	;allocate space for pcx files
		mov ax,501h
		xor cx,cx	;allocate 1MB of memory (to be safe)
		mov bx,20h
		int 31h
		jnc SAOKPCX

		mov edi,offset AllocErr
		mov ah,1
		xor ebx,ebx
		xor eax,eax
		xor edx,edx
		call PrintError
		mov ax,4c00h
		int 21h
	SAOKPCX:

		shl ebx,16	;assume it worked
		mov bx,cx
		mov [buffer],ebx
		mov [btemp],ebx


	;allocate space for zbuffer
		mov ax,501h
		mov cx,8000h	;allocate 600k of memory
		mov bx,9h
		int 31h
		shl ebx,16	;assume it worked
		mov bx,cx
		mov [zbuffer],ebx