		cmp ax,1f13h	;Ctrl-S (save)
		jne NotSaving


		;prepair to save
		;clear file name buffer
		mov [varstr],0		;string terminator
		mov [cmax],0

		;get filename  -use ClrMouse as a buffer (clears anyway)
	GetName:
		mov eax,[ClrMouse]
		mov [pt1x],70+640
		add eax,512		;go deep enough into buffer
		mov [pt1y],210+480
		mov word ptr fs:[eax],0h	;black
		mov [pt2x],570+640
		mov [pt2y],210+480
		mov [pt3x],70+640
		mov [pt3y],250+480
		mov [pt4x],570+640
		mov [pt4y],250+480

		mov [Shade],0
		;mov [skipaa],1
		mov [MapOffset],eax
		mov [pixlen],1
		mov [pixheight],1
		mov [AllowDepth],0
		call TextureMap	;blank area for writing
		;mov [skipaa],0
		mov [AllowDepth],1
		;write save as string
		mov cx,71
		mov bx,211
		mov edx,0a000ah
		mov esi,offset savestr
		call Write

		mov cx,71
		mov bx,231
		mov edx,0a000ah
		mov esi,offset varstr
		call Write

		;update screen
		FlushSBuffer

		;get a key
		xor ax,ax
		int 16h

		cmp ax,1c0dh	;enter - all done
		je GotName

		cmp ax,011bh	;escape
		je Bigloop

		cmp ax,0e08h	;backspace
		jne NotBKSPCF
			cmp [cmax],0	;gaurd against no string
			je GetName

			dec [cmax]
			mov eax,[cmax]	;get offset
			mov [varstr+eax],0	;terminate string
			jmp GetName
	NotBKSPCF:

		;store character on end of string
		mov ebx,[cmax]		;my temporary
		mov [varstr+ebx],al	;store keystorke
		mov [varstr+ebx+1],0	;terminate
		inc [cmax]
		jmp GetName



	GotName:	;now save
		mov esi,offset varstr
		mov al,W	;write only
		call fopen	;open file
		mov [temp],ax	;temp is the file handle

		;write Header
		mov bx,[temp]
		push fs
		push ds
		pop fs
		mov cx,5
		mov esi,offset fheader
		call fwrite
		pop fs	

	;-----------------------------------
		;write object
		mov bx,[temp]
		mov cx,SizeofObjectS
		mov esi,[NewObject]
		call fwrite

		;write polygons
		mov edi,[NewObject]
		mov ax,fs:[(Object + edi).NumPolys]
		mov bx,SizeofPolyS	;calculate size
		mul bx
		shl edx,16
		mov dx,ax	;edx contains length of polygons
		mov ecx,edx	;number of bytes to copy
		mov esi,fs:[(Object + edi).ToPolys]
		mov bx,[temp]
		call fwrite

	;-----------------------------------
		;write points
		mov esi,[NewObject]
		mov cx,fs:[(Object + esi).NumPolys]
		mov edi,fs:[(Object + esi).ToPolys]
	  PointWrite:
		push cx
		xor ax,ax
		mov al,fs:[(Polygon + edi).NumPoints]
		mov esi,fs:[(Polygon + edi).ToPoints]
		inc al
		mov cx,ax	;quick way of multiplying by 6
		shl ax,2	;""
		add cx,ax	;""
		push edi	;save to the polys (esi has to points)
		add cx,ax	;"" cx has # of bytes to save
		mov bx,[temp]
		call fwrite	;write cx bytes from esi

		pop edi		;to polys
		pop cx		;number of polys done
		add edi,SizeofPolyS	;go to next poly
		dec cx
		cmp cx,0
		ja PointWrite


	;-----------------------------------
		;write Texture Maps
		mov esi,[NewObject]
		mov cx,fs:[(Object + esi).NumPolys]
		mov edi,fs:[(Object + esi).ToPolys]
	  TMWrite:
		push cx
		mov ax,fs:[(Polygon + edi).numlpix]	;load width & height
		mov bx,fs:[(Polygon + edi).numhpix]
		mov esi,fs:[(Polygon + edi).ToMap]
		mul bx		;multiply width by height to get length
		shl edx,16
		mov dx,ax	;edx contains length
		push edi	;save to the polys (esi has to points)
		mov ecx,edx	;cx has # of bytes to save
		shl ecx,1	;2 bytes/pixel
		mov bx,[temp]
		call fwrite	;write cx bytes from esi

		pop edi		;to polys
		pop cx		;number of polys done
		add edi,SizeofPolyS	;go to next poly
		dec cx
		cmp cx,0
		ja TMWrite



		mov bx,[temp]
		call fclose	;done saving
		jmp Bigloop
	NotSaving:

;---------------------------------------------------------------------------
	;when do opening in game, etc. crunch the mem locations as tight as
	;possible
		;see if opening
		cmp ax,180fh	;Ctrl O
		jne NotOpening


		;prepair to open
		;clear file name buffer
		mov [varstr],0		;string terminator
		mov [cmax],0

		;get filename  -use ClrMouse as a buffer (clears anyway)
	GetOpenName:
		mov eax,[ClrMouse]
		mov [pt1x],70+640
		add eax,512		;go deep enough into buffer
		mov [pt1y],210+480
		mov word ptr fs:[eax],0h	;black
		mov [pt2x],570+640
		mov [pt2y],210+480
		mov [pt3x],70+640
		mov [pt3y],250+480
		mov [pt4x],570+640
		mov [pt4y],250+480

		mov [Shade],0
		;mov [skipaa],1
		mov [MapOffset],eax
		mov [pixlen],1
		mov [pixheight],1

		mov [AllowDepth],0
		call TextureMap	;blank area for writing
		;mov [skipaa],0
		mov [AllowDepth],1

		;write save as string
		mov cx,71
		mov bx,211
		mov edx,0a000ah
		mov esi,offset openstr
		call Write

		mov cx,71
		mov bx,231
		mov edx,0a000ah
		mov esi,offset varstr
		call Write

		;update screen
		FlushSBuffer

		;get a key
		xor ax,ax
		int 16h

		cmp ax,1c0dh	;enter - all done
		je GotOpenName

		cmp ax,011bh	;escape
		je Bigloop

		cmp ax,0e08h	;backspace
		jne NotOBKSPCF
			cmp [cmax],0	;gaurd against no string
			je GetOpenName

			dec [cmax]
			mov eax,[cmax]	;get offset
			mov [varstr+eax],0	;terminate string
			jmp GetOpenName
	NotOBKSPCF:

		;store character on end of string
		mov ebx,[cmax]		;my temporary
		mov [varstr+ebx],al	;store keystorke
		mov [varstr+ebx+1],0	;terminate
		inc [cmax]
		jmp GetOpenName



	GotOpenName:	;now save
		mov esi,offset varstr
	  OpenFromName:		;already have name in esi
		mov al,R	;write only
		call fopen	;open file
		mov [temp],ax	;temp is the file handle

		;see if valid file format
		mov bx,[temp]
		mov cx,5
		call fread

		mov ax,cs:[6]
		push es
		mov es,ax
		cmp byte ptr es:[0],'3'
		jne IFFS
		cmp byte ptr es:[1],'d'
		jne IFFS
		cmp byte ptr es:[2],'g'
		jne IFFS
		cmp byte ptr es:[3],'C'
		jne IFFS
		cmp byte ptr es:[4],'H'
		jne IFFS
		pop es

	;-----------------------------------
		;read object
		mov bx,[temp]
		mov cx,SizeofObjectS
		call fread

		mov ax,cs:[6]	;file buffer selector
		mov edi,[NewObject]
		xor esi,esi
		push es		;switch es to fs
		push fs
		pop es
		push ds		;save ds and move in file buffer
		mov ds,ax
		mov ecx,SizeofObjectS	;number of bytes
	    rep movsb		;move bytes to real object
		pop ds
		pop es

	;-----------------------------------
		;read polys
		;write polygons
		mov edi,[NewObject]
		mov ax,fs:[(Object + edi).NumPolys]
		mov bx,SizeofPolyS	;calculate size
		mul bx
		shl edx,16
		mov dx,ax	;edx contains length of polygons
		mov ecx,edx	;number of bytes to copy
		mov dword ptr [tx],ecx	;temporary storage
		mov bx,[temp]
		call fread

		mov edi,[NewObject]	;location to put polys
		mov eax,edi
		add eax,60
		mov fs:[(Object + edi).ToPolys],eax
		mov edi,eax

		;move into correct location from buffer
		mov bx,cs:[6]	;file buffer selector
		xor esi,esi
		mov ecx,dword ptr [tx] ;number of bytes
		push es		;switch es to fs
		push fs
		pop es
		push ds		;save ds and move in file buffer
		mov ds,bx
	    rep movsb		;move bytes to real object
		pop ds
		pop es


	;-----------------------------------
		;read points
		mov esi,[NewObject]
		mov cx,fs:[(Object + esi).NumPolys]
		mov edi,fs:[(Object + esi).ToPolys]

		mov eax,esi
		add eax,8000h
		mov [vertsat],eax	;where to put points
	  PointRead:
		push cx
		xor ax,ax
		mov al,fs:[(Polygon + edi).NumPoints]
		mov ebx,[vertsat]	;load location of points
		mov fs:[(Polygon + edi).ToPoints],ebx
		xor ecx,ecx
		inc al
		mov cx,ax	;quick way of multiplying by 6
		shl ax,2	;""
		add cx,ax	;""
		push edi	;save to the polys (esi has to points)
		add cx,ax	;"" cx has # of bytes to open
		mov dword ptr [tx],ecx	;store # of bytes
		mov bx,[temp]
		call fread	;write cx bytes from esi

		;move into correct location from buffer
		mov edi,[vertsat]
		mov bx,cs:[6]	;file buffer selector
		xor esi,esi
		mov ecx,dword ptr [tx] ;number of bytes
		push es		;switch es to fs
		push fs
		pop es
		push ds		;save ds and move in file buffer
		mov ds,bx
	    rep movsb		;move bytes to real object
		pop ds
		pop es

		mov eax,dword ptr [tx]	;add on 
		pop edi		;to polys
		add [vertsat],eax	;moves output of points

		pop cx		;number of polys done
		add edi,SizeofPolyS	;go to next poly
		dec cx
		cmp cx,0
		ja PointRead

		;tack 32000x3 on end (terminate point string
		mov edi,[vertsat]
		mov word ptr fs:[edi],32000
		mov word ptr fs:[edi+2],32000
		mov word ptr fs:[edi+4],32000
		mov esi,[NewObject]
		mov dword ptr fs:[esi+40],edi  ;ptr to points


	;-----------------------------------

		;read texturemaps
		mov esi,[NewObject]
		mov cx,fs:[(Object + esi).NumPolys]
		mov edi,fs:[(Object + esi).ToPolys]

		mov eax,esi
		add eax,10000h
		mov [vertsat],eax	;where to put points
	  TMRead:
		push cx
		mov ax,fs:[(Polygon + edi).numlpix]	;load width & height
		mov cx,fs:[(Polygon + edi).numhpix]
		mov ebx,[vertsat]	;load location of points
		mov fs:[(Polygon + edi).ToMap],ebx
		mul cx		;multiply width by height to get length
		shl edx,16
		mov dx,ax	;edx contains length
		push edi	;save to the polys (esi has to points)
		mov ecx,edx	;cx has # of bytes to save
		shl ecx,1	;2 bytes/pixel
		mov dword ptr [tx],ecx	;store # of bytes
		mov bx,[temp]
		call fread	;write cx bytes from esi

		;move into correct location from buffer
		mov edi,[vertsat]
		mov bx,cs:[6]	;file buffer selector
		xor esi,esi
		mov ecx,dword ptr [tx] ;number of bytes
		push es		;switch es to fs
		push fs
		pop es
		push ds		;save ds and move in file buffer
		mov ds,bx
	    rep movsb		;move bytes to real object

		mov eax,ds:[esi-4]	;clear
		mov ecx,64		;32 * 4 = 64 bytes
	    rep stosd
		pop ds
		pop es

		mov eax,dword ptr [tx]	;add on
		pop edi		;to polys
		add eax,128	;breathing room between maps
		add [vertsat],eax	;moves output of points

		pop cx		;number of polys done
		add edi,SizeofPolyS	;go to next poly
		dec cx
		cmp cx,0
		ja TMRead

		mov edi,[NewObject]
		mov eax,[vertsat]
		;add eax,64
		mov dword ptr fs:[edi+52],eax ;pointer to texture maps

		mov bx,[temp]
		call fclose	;done saving

		mov [state],0
		jmp Bigloop
	NotOpening:

;---------------------------------------------------------------------------
	;get new file (open default.3dg)
		cmp ax,310eh	;Ctrl - N
		jne NotNew
		mov esi,offset deffile
		jmp OpenFromName


		;subroutine for invalid file format
		IFFS:
			pop es
			mov cx,200
			mov bx,100
			mov edx,0a000ah
			mov esi,offset invalid
			call Write
			FlushSBuffer
			xor ax,ax
			int 16h
			jmp Bigloop

	NotNew: