.486p
.MODEL huge,C
.stack 2600h

include defines.inc

;***Code********************************************************************
CCSEG              SEGMENT PARA    PUBLIC  'CODE'    USE32
		ASSUME  CS:CCSEG, DS:CCSEG, ES:CCSEG, SS:CCSEG
      ORG 00000100h

GO:		mov [ModeToSet],111h ;5fh

		;isgood test
		cmp byte ptr [myname],'C'
		jne EndLoop

		call Initialize
		;include afi.inc

		cmp [myname+18],'h'
		jne EndLoop
		cmp [prgname],'C'
		jne EndLoop
		cmp [prgname+8],'3'
		jne EndLoop

		mov [state],0

		include eobj.inc
		;fs:[(Object + edi). ???] = pointer to main object

		mov [pointerx],0
		mov [pointery],0
		mov [pointerz],0

		mov [lightx],0h
		mov [lighty],100h
		mov [lightz],0h

		mov [TopOfScreen],240 + 480
		mov [LeftOfScreen],320 + 640
		;mov [skipaa],0
		mov [AllowDepth],1
		mov [background],0h
		mov [foreground],0ffffh	;white
		call InitMouse
		;call SetMouseHandler

Bigloop:
	;Clear Screen
		clrscrbfr

	inc [blcount]
	inc [gencount]

	cmp [blcount],1
	jne DoNotDispC
	jmp PrognCInfo
	DoNotDispC:


	;Draw Axis
		mov edi,[NewObject]
		cmp [DrawAxis],1	;if turned off, don't draw
		jne SkipAxis
		cmp fs:[(Object + edi).ztrans],-200
		jl SkipAxis
		include axis.inc
	   SkipAxis:
		;mov [skipaa],0
	;Draw Object

		;plot mouse on clear texture

		mov edi,[NewObject]
	;include buffer.inc
	;cmp [dummy2],1
	;jne NotCFirst
		mov [skipaa],0
		mov edi,[NewObject]
		call DrawObject
;include norm.inc
comment ~
mov edi,[NewObject]
mov edi,fs:[(Object + edi).ToPolys]
mov ax,fs:[(Polygon + edi).normx]
mov bx,fs:[(Polygon + edi).normy]
mov dx,fs:[(Polygon + edi).normz]
sar ax,1
sar bx,1
sar dx,1
;neg ax
;neg bx
;neg dx
mov [rx],ax
mov [ry],bx
mov [rz],dx
call Rotate
mov eax,dword ptr [rx]
;mov bx,[ry]
mov dx,[rz]
mov dword ptr [pt1x],eax
mov [pt1z],dx

mov ax,0ffffh
call Plot
~

		mov [skipaa],1
	;NotCFirst:
		cmp [DrawStat],1	;if not drawing stats, skip box
		jne DispBoxSkip
		mov edi,[NewObject]
		include box.inc
	DispBoxSkip:
	;	cmp [dummy2],1
	;	je CFirst
	;	mov edi,[NewObject]
	;	call DrawObject
	;CFirst:



	;draw stats
	cmp [DrawStat],1	;if not set to draw, then don't
	jne DisplaySkip

	;if above state 0 - box moving data
		cmp [state],0
		je SkipDspds
		cmp [state],4
		jae SkipDspds
		;cmp [state],5
		;je SkipDspds
		include dispds.inc
	SkipDspds:

	;if state 2 - move polygon box
		cmp [state],2
		jne SkipDspdsp
		include dispdsp.inc
	SkipDspdsp:

	;if state 3 - move around points - flexi
		cmp [state],3
		jne SkipFlx
		include dispf.inc
	SkipFlx:

	;if state 4 - edit polygon texturemaps
		cmp [state],4
		je GOTME
		cmp [state],5
		jne SkipTME
		cmp [gencount],2 ;see if starting new drawing sequence
		jne GOTME
		call InitMEdit
	  GOTME:
		mov edi,[NewObject]
		include disptme.inc
	SkipTME:

		cmp [state],6
		jne SkipLightd
		include displit.inc
	SkipLightd:


		include dispd.inc	;draw standard stuff

	;Draw Mouse to screen
		include ms.inc

  DisplaySkip:				;jump here if viewing only

comment ~
;Cool -insert right above FlushSBuffer
mov esi,[zbuffer]
xor edi,edi

mov ax,[ScreenBuffer]
push es
mov es,ax

mov ecx,640*480

uuu:
	mov ax,fs:[esi + edi*2]
	mov es:[2*edi],ax
	inc edi
	sub ecx,1
	jnz uuu

pop es

~

		;call aaflush
		;include af8.inc
		FlushSBuffer

	;Get Key
		mov ah,1	;see if key is waiting
		int 16h
		jz Bigloop

		push ax		;save key if one is

	GetKey:
		xor ax,ax	;get the key
		int 16h

		mov ah,1	;clear kb buffer
		int 16h
		jnz GetKey

		pop ax		;restore key code

	;handle keyboard info
		mov edi,[NewObject]
		include kb.inc

EndLoop:
;put back in to calculate fps
;38.9 fps -best
;mov edx,[blcount]
;sa
		call ReturnMode			;ditto - this is @exit
		mov ax,4c00h			;""
		int 21h				;""

include var.inc

include draw.inc	;texture map, lines, plots
include math.inc	;surface normal, trig, etc.
include video.inc	;video library
include file.inc	;file access
include font.inc	;font drawer
include pcx.inc		;pcx opener
include mouse.inc	;mouse handlers
include af.inc
include fx.inc		;effects

			;use for displaying copyright stuff

CCSEG ENDS
END GO
END