SQRT proc
	mov edi,eax
	cmp ebp,0
	jne calc_sqrt_Loop
	ret
;----- Main Loop that makes EBP converge to the square root of EDI ------
 calc_sqrt_Loop:
        push EBP		; save x  so can check if x has converged
        mov  EBX,EBP
        shl  EBX,1		; ebx = f'(x) = 2x

        mov  EAX,EBP
        mul EBP
        sub  EAX,EDI		; eax = f(x) = X*X - Root_value
        sbb  EDX,0		; use 64bit subtract

        idiv  EBX               ; eax = f(Xn) / f'(Xn)

	sub  EBP,EAX		; ebp =   Xn+1   =   Xn - f(Xn) / f'(Xn)
        pop  EAX		; look at old value
        cmp  EBP,EAX		; loop only if new value is different
      jne calc_sqrt_Loop
;-------------------------- End of Loop --------------------------------

        mov eax,ebp     ; EBP now contians the square root of EDI
	ret
SQRT    Endp