ALIGN 4
include tables.inc
Map	dd	(?)
;	dd	1000h dup (1048a830h);(00081008h)
				;(0f0e8e8f0h) ;(00182810h)
ClrMap	dd	(?)
;dd	4000h dup (0ffffffffh)
ClrMouse dd	(?)
;dd	4000h dup (0ffffffffh)
TopOfScreen     dw (240) ;see Plot function
LeftOfScreen    dw (320) ;3x3 screens -need this for
				 ;translating x & y values to screen
				 ;from this 'screen'
zbuffer	dd	(?)	;pointer to storage space for depth of each pixel

blcount	dd	(0)	;counts how many times the big loop has gone
gencount dd	(0)	;general counter
lastx dw (?)
lasty dw (?)
skipaa db (1)
db (?)

lightix	dw	(0h)		;to begin with
lightiy	dw	(100h)
lightiz	dw	(0h)
lightx	dw	(0h)		;these are modified
lighty	dw	(100h)
lightz	dw	(0h)
lrotx	db	(0)		;with these rotations
lroty	db	(0)
lrotz	db	(0)
	db	(0)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ALIGN 16
;texturemap editing vars
OnColor	dw	(0)	;current color
ColPt	db	(0)	;argb -which pointing to
clen	dw	(?)	;length - storing for painting
cheight	dw	(?)	;height - ""
cMap	dd	(?)	;map of texture being edited
lxstart	dw	(0)	;starting of line in texture maps
lystart	dw	(0)	;""
cmax	dd	(?)	;max space for map

ttemp	dd	(?)	;extra temp
atemp	dd	(?)
ctemp	dd	(?)

zzindex	dw (0)		;for cycling through points
plotyet	dw (?)		;see if plotted point yet, and counts points


DrawAxis dw	(1)	;whether or not to draw axis in background
DrawStat dw	(1)	;whether or not to draw all stats

state		dd (?)
;use these for calling texturemapping
pt1x            dw (?)
pt1y            dw (?)
pt1z            dw (?)
pt2x            dw (?)
pt2y            dw (?)
pt2z            dw (?)
pt3x            dw (?)
pt3y            dw (?)
pt3z            dw (?)
pt4x            dw (?)
pt4y            dw (?)
pt4z            dw (?)
Xa		dd (?)
Ya		dd (?)
Za		dd (?)

numverts	db (?)
vertcount	db (?)

mpointerx	dw (?)
mpointery	dw (?)
mpointerz	dw (?)
pointerx	dw (?)
pointery	dw (?)
pointerz	dw (?)
tpointerx	dw (?)
tpointery	dw (?)
tpointerz	dw (?)
;outline box stuff
brotx	db	(0)	;box rotation
broty	db	(0)
brotz	db	(0)
	db	(?)
bfptrx	dw	(0)	;move around relative to rotation point
bfptry	dw	(0)
bfptrz	dw	(0)
bpointerx dw	(0)	;place of rotation point
bpointery dw	(0)
bpointerz dw	(0)
box dw  -30, -30, 0, 30, -30, 0, 30, 30, 0, -30, 30, 0, -30, -30, 0
nextbox dw -30, -30, 0, 30, -30, 0, 30, 30, 0, -30, 30, 0, -30, -30, 0

;Side		Polygon	6 dup ({})
include side.inc

tmeditat dw 400, 300, 0	;texture map editor x, y, extention
tmex	dw	(0)
tmey	dw	(0)

kv		dw (2) ;keyboard movement speed

bcolor		dw (25*8)

fxres		dw (4) ;resolution for flexi-polys
fyres		dw (4) ;""

ObjPtr		dd (?)
NewObject	dd (?)
vertsat		dd (?)

cxtemp		dw (?)
direction	dw (?)
MapOffset	dd (?)
DrawTo		dd (?)

pixlen		dw (?) ;original lenght and height (# of pixels)
pixheight	dw (?)
Displace	dd (?)
RunningTotal	dd (?)
hDisplace	dd (?)
hRunningTotal	dd (?)

zRunningTotal	dd (?)
zDisplace	dd (?)
zhRunningTotal	dd (?)
zhDisplace	dd (?)
zhrRunningTotal	dd (?)
zhrDisplace	dd (?)

xval		dw (?)
yval		dw (?)
xval2		dw (?)
yval2		dw (?)
deltax		dw (?)
deltay		dw (?)
hxval		dw (?)
hyval		dw (?)
hxval2		dw (?)
hyval2		dw (?)
hdeltax		dw (?)
hdeltay		dw (?)
det1		dw (?)
det2		dw (?)
hdet1		dw (?)
hdet2		dw (?)
d		dw (?)
hd		dw (?)
numpixels	dw (?)
hnumpixels	dw (?)
hrxval		dw (?)
hryval		dw (?)
hrxval2		dw (?)
hryval2		dw (?)
hrdeltax	dw (?)
hrdeltay	dw (?)
hrdet1		dw (?)
hrdet2		dw (?)
hrd		dw (?)
hrnumpixels	dw (?)
htrap		dd (?)
hrtrap		dd (?)
ht		dd (?)
hrt		dd (?)
htlast		dw (?)
hrtlast		dw (?)
which		dw (?)
;skipaa		dw (?)

background	dd (?)
foreground	dw (?)
Shade		dw (?) ;shade of color (what to add before plotting)
DispDegrees	dw (1)
temp		dw (?)
htemp		dw (?)

AllowDepth	dw (?) ;set if allowing depth in texturemapping

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;use these for rotating & transitioning
tx	dw	(?)
ty	dw	(?)
tz	dw	(?)
rx	dw	(?)
ry	dw	(?)
rz	dw	(?)

rotx	db	(?)
roty	db	(?)
rotz	db	(?)
dummy2	db	(?)

sinx	dw	(?)
cosx	dw	(?)
siny	dw	(?)
cosy	dw	(?)
sinz	dw	(?)
cosz	dw	(?)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
prgname	db	'Creator 3d       ver 1.6',0
myname	db	'Copyright  1998 Chris Hazard  Hazardous Software',0

hidden	db	(0)	;flag to see if polygon uses hidden surface removal
hidestr	db	'hsr',0
nohidestr db	'no hsr',0

xstr	db	'x ', 0
ystr	db	'y ', 0
zstr	db	'z ', 0
rotstr	db	'rot ', 0
degrstr	db	'degrees',0
i256str	db	'256 scale',0
ol	db	'outline ',0
cspeed	db	'speed ',0
trans	db	'trans ',0
rotar	db	'rot around ',0
wstr	db	'width  ',0
hstr	db	'height ',0
normstr	db	'normal',0
realstr	db	'real',0
flexstr db	'flexi',0
xresstr db	'xres ',0
yresstr db	'yres ',0
posstr	db	'position',0
editstr	db	'edit texture map',0
magstr	db	'magnify ',0
savestr	db	'save as:',0
openstr	db	'open:',0
palstr	db	'palette file name:',0
deffile	db	'default.3dg',0
defpal	db	'default.pal',0
invalid	db	'invalid file format',0
fheader	db	'3dgCH'
pheader	db	'palCH'
pcxheader db	'pcx file to import',0
colstr	db	'color',0
lightstr db	'light',0
rstr	db	'r ',0
gstr	db	'g ',0
bstr	db	'b ',0
space	db	' ',0
mouseshade	db	0
varstr	db	101 dup (0)