mov [vertcount],-1
;inc [numverts]

aloop:
	xor edx,edx
	inc [vertcount]
	mov dl,[vertcount]
	cmp dl,[numverts]
	ja aAllDone
	cmp [vertcount],0
	jne Dontdo1

	mov edx,[vertsat]

	mov eax,dword ptr fs:[edx]
	;mov bx,word ptr fs:[edx + 2]
	mov cx,word ptr fs:[edx + 4]

	mov dword ptr [rx],eax
	;mov [ry],bx
	mov [rz],cx
	call Rotate

	movsx eax,[rx]		;load x
	movsx ebx,[rz]		;load z
	movsx edx,[tx]
	movsx ecx,[tz]
	add eax,edx
	add ebx,ecx
mov [pt1z],bx
	shl eax,zshift		;multiply eax by 256
	cdq
	add ebx,zadd		;add displacement to z
	idiv ebx		;divide edx:eax by ebx
	add ax,[LeftOfScreen] 	;move to where screen is
	mov [pt1x],ax		;save new x value
      ;y1
	movsx eax,[ry]		;load y
	movsx edx,[ty]
	add eax,edx
	shl eax,zshift		;mul ax by 256
	cdq
	idiv ebx		;divide dx:ax by bx
	add ax,[TopOfScreen]	;move to where screen is
	mov [pt1y],ax
	jmp aloop
Dontdo1:

	xor edx,edx
	mov dl,[vertcount]

	mov eax,edx
	shl edx,2
	shl eax,1
	add edx,eax
	add edx,[vertsat]

	mov eax,dword ptr fs:[edx]
	;mov bx,word ptr fs:[edx + 2]
	mov cx,word ptr fs:[edx + 4]
	mov dword ptr [rx],eax
	;mov [ry],bx
	mov [rz],cx
	call Rotate

	push word ptr [pt1x]
	push word ptr [pt1y]
	push word ptr [pt1z]
	movsx eax,[rx]		;load x
	movsx ebx,[rz]		;load z
	movsx edx,[tx]
	movsx ecx,[tz]
	add eax,edx
	add ebx,ecx
mov [pt1z],bx
	shl eax,zshift		;multiply eax by 256
	cdq
	add ebx,zadd		;add displacement to z
	idiv ebx		;divide edx:eax by ebx
	add ax,[LeftOfScreen] 	;move to where screen is
	mov [pt1x],ax		;save new x value
      ;y1
	movsx eax,[ry]		;load y
	movsx edx,[ty]
	add eax,edx
	shl eax,zshift		;mul ax by 256
	cdq
	idiv ebx		;divide dx:ax by bx
	add ax,[TopOfScreen]	;move to where screen is
	mov [pt1y],ax

	pop [pt2z]
	pop bx
	pop cx


aLineStart:
  ;initialize height: find deltax and deltay
   ;yval & xval are +/-1 to add/sub from value, depending on where line goes
	mov ax,[pt1x]		;load for later
	sub ax,cx		;pt1x - pt2x
	cmp ax,0		;see if negative
	jge aNotNeg		;
	neg ax
 aNotNeg:
	mov dx,[pt1y]		;load pt1
	sub dx,bx		;pt1y - pt2y
	cmp dx,0		;see if negative
	jge aYNotNeg		;
	neg dx
 aYNotNeg:
  ;Initialize Variables
	cmp ax,dx		;compair deltax to deltay
	jbe aJump1

	;deltax >= deltay
	shl dx,1
	mov [numpixels],ax
	mov [det1],dx
	mov [xval],1
	sub dx,ax
	mov [xval2],1
	mov [d],dx
	mov [yval],0
	sub dx,ax
	mov [yval2],1
	mov [det2],dx
	jmp aJumpE

 aJump1:
	;deltax < deltay
	shl ax,1
	mov [numpixels],dx
	mov [det1],ax
	mov [xval],0
	sub ax,dx
	mov [xval2],1
	mov [d],ax
	mov [yval],1
	sub ax,dx
	mov [yval2],1
	mov [det2],ax
 aJumpE:

	;Make sure it moves the right direction
	mov ax,[pt1x]
	cmp ax,cx
	jbe aSkipSX
	neg [xval]
	neg [xval2]
 aSkipSX:
	mov ax,[pt1y]
	cmp ax,bx
	jbe aSkipSY
	neg [yval]
	neg [yval2]
 aSkipSY:

  ;initialize z runners for point z buffering
	movsx ebx,[pt2z];load z depths of top and bottom
	movsx eax,[pt1z]
	sub eax,ebx

	xor ecx,ecx		;clear for later
	;shl ebx,16		;shift left for precision
	mov cx,[numpixels]	;get number of height pixels
	mov [zRunningTotal],ebx;save into zhRunningTotal

	mov edx,eax		;sign extend
	sar edx,31
	idiv ecx		;divide by # of pixels
	mov [zDisplace],eax	;store amount for each step


	xor ecx,ecx
	xor ebx,ebx
	mov cx,[pt1x]
	mov bx,[pt1y]
	mov [temp],0

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
aLine:
	cmp cx,640+639		;see if off screen
	jge aSkipPixel		;
	cmp cx,640
	jle aSkipPixel
	cmp bx,479+480		;see if off screen
	jge aSkipPixel		;
	cmp bx,480
	jle aSkipPixel

	push ebx
	push ecx

	xor eax,eax
	mov ax,bx

	sub eax,480
	and ecx,0000ffffh	;clear upper
	imul eax,640		;multiply eax by ebx (640*x)
				;stores in edx:eax, but only uses eax
	 ;cleared upper edx when shr edx,16  14 lines up
	add eax,ecx		;add offset of x to address
	shl eax,1
	sub eax,640*2
	mov [DrawTo],eax	;save for later
	add eax,[zbuffer]	;get adress
	mov dx,gs:[eax]		;get point
			;use gs because fs is used in text drawer

	mov ecx,[zRunningTotal]

	shr ecx,16
	add cx,32
	cmp cx,dx	;compare z to draw with the one already there
	jl aSkipPixel

;anti-alias point ScreenBuffer+eax
mov esi,[DrawTo]
;=========================================================================
	xor eax,eax			;
	xor ebx,ebx			;
	xor ecx,ecx			;
	xor edx,edx			;

	mov ax,es:[esi-2]		;grab points around point
	mov bx,es:[esi-640*2]
	mov cx,es:[esi+2]
	mov dx,es:[esi+640*2]
	and ax,11111b
	and bx,11111b
	and cx,11111b
	and dx,11111b
	add ax,bx
	add ax,cx
	add ax,dx
	mov bx,es:[esi]
	and bx,11111b
	shl bx,2
	add ax,bx
	shr ax,3
	mov bp,ax

	mov ax,es:[esi-2]		;grab points around point
	mov bx,es:[esi-640*2]
	mov cx,es:[esi+2]
	mov dx,es:[esi+640*2]
	shr ax,5
	shr bx,5
	shr cx,5
	shr dx,5
	and ax,111111b
	and bx,111111b
	and cx,111111b
	and dx,111111b
	add ax,bx
	add ax,cx
	add ax,dx
	mov bx,es:[esi]
	shr bx,5
	and bx,111111b
	shl bx,2
	add ax,bx
	shr ax,3
	shl ax,5
	or bp,ax

	mov ax,es:[esi-2]		;grab points around point
	mov bx,es:[esi-640*2]
	mov cx,es:[esi+2]
	mov dx,es:[esi+640*2]
	shr ax,11
	shr bx,11
	shr cx,11
	shr dx,11
	and ax,11111b
	and bx,11111b
	and cx,11111b
	and dx,11111b
	add ax,bx
	add ax,cx
	add ax,dx
	mov bx,es:[esi]
	shr bx,11
	and bx,11111b
	shl bx,2
	add ax,bx
	shr ax,3
	shl ax,11
	or bp,ax

	;mov ax,bp
	mov word ptr es:[esi],bp	;store new color & shade

;=========================================================================
aSkipPixel:
	mov ecx,[zRunningTotal]	;load for zbuffer
	add ecx,[zDisplace]	;add displacement
	mov [zRunningTotal],ecx	;store new zbuffer

	pop ecx
	pop ebx

	mov ax,[temp]
	inc ax
	mov dx,[d]		;
	cmp [numpixels],ax	;see if done
	jb aloop
	mov [temp],ax
	cmp dx,0
	jge aOther

	;d < 0
	add dx,[det1]
	add cx,[xval]
	mov [d],dx
	add bx,[yval]
	jmp aLine

 aOther:
	;d >= 0
	add dx,[det2]
	add cx,[xval2]
	mov [d],dx
	add bx,[yval2]
	jmp aLine
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

aAllDone: