;disp flexi if in state 3
	mov cx,10
	mov bx,5
	mov edx,0a000ah
	mov esi,offset flexstr
	call Write

	;disp resolution settings
	mov cx,500
	mov bx,242
	mov edx,0a000ah
	mov esi,offset xresstr
	call Write
	mov ax,[fxres]
	call ShowDec

	mov cx,500
	mov bx,253
	mov edx,0a000ah
	mov esi,offset yresstr
	call Write
	mov ax,[fyres]
	call ShowDec

	;display point selected for moving
	;set up rotation
	mov edi,[NewObject] ;get edi set right
	mov al,fs:[(Object + edi).xrot]
	mov bl,fs:[(Object + edi).yrot]
	mov dl,fs:[(Object + edi).zrot]
	mov [rotx],al
	mov [roty],bl
	mov [rotz],dl
	call RotSet
	;find point
	xor eax,eax
	mov ax,[fpointon]
	shl ax,1	;mul by 6 (mul by 2)
	mov bx,ax	;store 2*num
	shl ax,1	;mul by 2
	add ax,bx	;add 4*num to 2*num
	mov bx,[nextbox + eax]
	mov cx,[nextbox + eax + 2]
	mov dx,[nextbox + eax + 4]
	push bx		;save points for displaying coordinates
	push cx
	push dx
	mov [rx],bx	;rotate point
	mov [ry],cx
	mov [rz],dx
	call Rotate
	mov ax,[rx]
	mov bx,[ry]
	mov dx,[rz]
	add ax,fs:[(Object + edi).xtrans]
	add bx,fs:[(Object + edi).ytrans]
	add dx,fs:[(Object + edi).ztrans]
	mov [pt1x],ax
	mov [pt1y],bx
	mov [pt1z],dx
	mov ax,0F800h
	call Plot
	inc [pt1x]
	call Plot
	sub [pt1x],2
	call Plot
	inc [pt1x]
	inc [pt1y]
	call Plot
	sub [pt1y],2
	call Plot


	;display 3d coordinates
	mov cx,500
	mov bx,270
	mov edx,0a000ah
	mov esi,offset posstr
	call Write

	mov cx,500
	mov bx,308
	mov edx,0a000ah
	mov esi,offset zstr
	call Write
	pop ax		;the z from earlier
	call ShowDec

	mov cx,500
	mov bx,297
	mov edx,0a000ah
	mov esi,offset ystr
	call Write
	pop ax		;the y from earlier
	call ShowDec

	mov cx,500
	mov bx,286
	mov edx,0a000ah
	mov esi,offset xstr
	call Write
	pop ax		;the x from earlier
	call ShowDec


	;disp status of hidden surface removal ('hsr')
	mov cx,10
	mov bx,21
	mov edx,0a000ah
	mov esi,offset hidestr
	cmp [hidden],0
	je HSREndf
	mov esi,offset nohidestr
  HSREndf:
	call Write