;****************************************************************************
;Flushing Ques procedure
;   calling:	que has pointer to polyq, quearray has pointer to array
;			of (word z-depth, dword ptrtopolyq)
FlushQues proc

	;preset pointers
	mov eax,[quearray]
	sub eax,6
	mov [qaptr],eax

 ;do sorting here
	xor ebx,ebx
	mov eax,[quearray]
	mov bx,[qlen]
	mov dword ptr [pt3z],esp	;keep stack (need?)
	push ebx	;number of polys
	push eax	;pointer to  quearray
	call qsort
	;pop eax	;realign stack
	;pop eax
	mov esp,dword ptr [pt3z]	;keep stack (need?)

 DFLoop:
	add [qaptr],6	;move along que
	mov esi,[qaptr]
	dec [qlen]
	cmp [qlen],-1	;see if done
	je DFLoopE

	mov esi,fs:[esi+2]		;get pointer to polyq

	;transfer points (use dword for speed - x&y in 1 swing)
	mov eax,dword ptr fs:[(PolygonQue + esi).p1x]
	mov ebx,dword ptr fs:[(PolygonQue + esi).p2x]
	mov dword ptr [pt1x],eax
	mov dword ptr [pt2x],ebx
	mov eax,dword ptr fs:[(PolygonQue + esi).p3x]
	mov ebx,dword ptr fs:[(PolygonQue + esi).p4x]
	mov dword ptr [pt3x],eax
	mov dword ptr [pt4x],ebx

	mov edx,fs:[(PolygonQue + esi).qToMap]	;load Texture Map
	mov ax,fs:[(PolygonQue + esi).qnumlpix];transfer # of pixels
	mov [MapOffset],edx		;store Texture Map
	mov cl,fs:[(PolygonQue + esi).qNumPoints]
	mov bx,fs:[(PolygonQue + esi).qnumhpix]
	mov [numverts],cl
	mov edx,fs:[(PolygonQue + esi).qToPoints]
	mov [pixlen],ax
	mov [vertsat],edx
	mov [pixheight],bx
	mov al,fs:[(PolygonQue + esi).shade]
	mov [Shade],al

	call TextureMap

	jmp DFLoop
 DFLoopE:
	ret
ENDP

include q.inc