;Highlights all points where z = 0
	mov cl,fs:[(Object + edi).NumPolys]
	mov esi,fs:[(Object + edi).ToPolys]
	mov ax,fs:[(Object + edi).xtrans]
	mov bx,fs:[(Object + edi).ytrans]
	mov dx,fs:[(Object + edi).ztrans]
	mov [tx],ax
	mov [ty],bx
	mov [tz],dx

HiliteLoop:
	push ecx
	xor cx,cx
	mov edi,fs:[(Polygon + esi).ToPoints]
	mov cx,fs:[(Polygon + esi).NumPoints]
 PolyZLoop:

	mov ax,fs:[(Points + edi).x]
	mov bx,fs:[(Points + edi).y]
	mov dx,fs:[(Points + edi).z]
	push ecx
	mov [rx],ax
	mov [ry],bx
	mov [rz],dx
	call Rotate
	mov ax,[rx]
	mov bx,[ry]
	mov dx,[rz]
	add ax,[tx]
	add bx,[ty]
	add cx,[tz]
	mov [pt3x],ax
	mov [pt3y],bx
	mov [pt3z],cx

	cmp cx,0
	jne SkipThisZ
  ;Make Point noticeable if its z = 0
	mov [color],25*8
	add ax,4
	mov [pt1x],ax
	sub ax,8
	mov [pt2x],ax
	mov [pt2y],bx
	mov [pt2z],cx
	mov [pt1y],bx
	mov [pt1z],cx
	call DrawLine
	mov ax,[pt3x]
	mov dx,[pt3y]
	mov [pt1x],ax
	add dx,4
	mov [pt1y],dx
	mov [pt2x],ax
	sub dx,8
	mov [pt2y],dx
	call DrawLine
	
	
  SkipThisZ:
	pop ecx
	add edi,SizeofPointS
	dec cx
	jnz PolyZLoop



	pop ecx
	add esi,SizeofPolyS
	dec cl
	jnz HiliteLoop